Index: palm/trunk/SOURCE/package_parin.f90
===================================================================
--- palm/trunk/SOURCE/package_parin.f90	(revision 1821)
+++ palm/trunk/SOURCE/package_parin.f90	(revision 1822)
@@ -19,5 +19,7 @@
 ! Current revisions:
 ! -----------------
-! 
+! +collision_algorithm
+!
+! Tails removed.
 ! 
 ! Former revisions:
@@ -137,15 +139,13 @@
     USE particle_attributes,                                                   &
         ONLY:  alloc_factor, bc_par_b, bc_par_lr, bc_par_ns, bc_par_t,         &
-               collision_kernel, density_ratio, dissipation_classes,           &
-               dt_min_part, dt_prel, dt_write_particle_data, dvrp_psize,       &
+               collision_algorithm, collision_kernel, density_ratio,           &
+               dissipation_classes, dt_min_part, dt_prel,                      &
+               dt_write_particle_data,                                         &
                end_time_prel, initial_weighting_factor,                        &
-               maximum_number_of_tailpoints,                                   &
-               maximum_tailpoint_age, minimum_tailpoint_distance,              &
                min_nr_particle, number_of_particle_groups, particles_per_point,&
                particle_advection, particle_advection_start, pdx, pdy, pdz,    &
                psb, psl, psn, psr, pss, pst, radius, radius_classes,           &
                random_start_position, read_particles_from_restartfile,         &
-               seed_follows_topography, skip_particles_for_tail,               &
-               use_particle_tails, use_sgs_for_particles,                      &
+               seed_follows_topography, use_sgs_for_particles,                 &
                vertical_particle_advection, write_particle_statistics
 
@@ -186,5 +186,5 @@
                                   dt_dvrp, dvrpsize_interval, dvrp_directory,  &
                                   dvrp_file, dvrp_host, dvrp_output,           &
-                                  dvrp_password, dvrp_psize, dvrp_username,    &
+                                  dvrp_password, dvrp_username,                &
                                   groundplate_color, isosurface_color,         &
                                   mode_dvrp, particle_color, particle_dvrpsize,&
@@ -199,12 +199,10 @@
 
     NAMELIST /particles_par/      alloc_factor, bc_par_b, bc_par_lr,           &
-                                  bc_par_ns, bc_par_t, collision_kernel,       &
+                                  bc_par_ns, bc_par_t, collision_algorithm,    &
+                                  collision_kernel,                            &
                                   density_ratio, dissipation_classes, dt_dopts,&
                                   dt_min_part, dt_prel,                        &
                                   dt_write_particle_data,                      &
                                   end_time_prel, initial_weighting_factor,     &
-                                  maximum_number_of_tailpoints,                &
-                                  maximum_tailpoint_age,                       &
-                                  minimum_tailpoint_distance,                  &
                                   min_nr_particle,                             &
                                   number_of_particle_groups,                   &
@@ -216,6 +214,5 @@
                                   read_particles_from_restartfile,             &
                                   seed_follows_topography,                     &
-                                  skip_particles_for_tail,                     &
-                                  use_particle_tails, use_sgs_for_particles,   &
+                                  use_sgs_for_particles,                       &
                                   vertical_particle_advection,                 &
                                   write_particle_statistics
Index: palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- palm/trunk/SOURCE/prognostic_equations.f90	(revision 1821)
+++ palm/trunk/SOURCE/prognostic_equations.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Kessler microphysics scheme moved to microphysics.  
 ! 
 ! Former revisions:
@@ -190,13 +190,13 @@
     USE control_parameters,                                                    &
         ONLY:  call_microphysics_at_all_substeps, cloud_physics,               &
-               cloud_top_radiation, constant_diffusion, dp_external,       &
+               cloud_top_radiation, constant_diffusion, dp_external,           &
                dp_level_ind_b, dp_smooth_factor, dpdxy, dt_3d, humidity,       &
-               icloud_scheme, inflow_l, intermediate_timestep_count,           &
+               inflow_l, intermediate_timestep_count,                          &
                intermediate_timestep_count_max, large_scale_forcing,           &
-               large_scale_subsidence, neutral, nudging, ocean, outflow_l,     &
-               outflow_s, passive_scalar, precipitation,                       &
-               prho_reference, prho_reference, prho_reference, pt_reference,   &
-               pt_reference, pt_reference, scalar_advec, scalar_advec,         &
-               simulated_time, sloping_surface,                                &
+               large_scale_subsidence, microphysics_seifert,                   &
+               microphysics_sat_adjust, neutral, nudging, ocean, outflow_l,    &
+               outflow_s, passive_scalar, prho_reference, prho_reference,      &
+               prho_reference, pt_reference, pt_reference, pt_reference,       &
+               scalar_advec, scalar_advec, simulated_time, sloping_surface,    &
                timestep_scheme, tsc, use_subsidence_tendencies,                &
                use_upstream_for_tke, wall_heatflux,                            &
@@ -247,7 +247,4 @@
     USE buoyancy_mod,                                                          &
         ONLY:  buoyancy, buoyancy_acc
-
-    USE calc_precipitation_mod,                                                &
-        ONLY:  calc_precipitation
 
     USE calc_radiation_mod,                                                    &
@@ -271,7 +268,4 @@
     USE diffusion_w_mod,                                                       &
         ONLY:  diffusion_w, diffusion_w_acc
-
-    USE impact_of_latent_heat_mod,                                             &
-        ONLY:  impact_of_latent_heat
 
     USE kinds
@@ -377,6 +371,6 @@
        DO  j = nys, nyn
 !
-!--       If required, calculate cloud microphysical impacts (two-moment scheme)
-          IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                 &
+!--       If required, calculate cloud microphysics
+          IF ( cloud_physics  .AND.  .NOT. microphysics_sat_adjust  .AND.      &
                ( intermediate_timestep_count == 1  .OR.                        &
                  call_microphysics_at_all_substeps )                           &
@@ -584,11 +578,4 @@
              IF ( cloud_top_radiation )  THEN
                 CALL calc_radiation( i, j )
-             ENDIF
-
-!
-!--          If required compute impact of latent heat due to precipitation
-             IF ( cloud_physics  .AND.  icloud_scheme == 1  .AND.              &
-                  precipitation )  THEN
-                CALL impact_of_latent_heat( i, j ) 
              ENDIF
 
@@ -729,12 +716,4 @@
 
 !
-!--          If required compute decrease of total water content due to
-!--          precipitation
-             IF ( cloud_physics  .AND.  icloud_scheme == 1  .AND.              &
-                  precipitation )  THEN
-                CALL calc_precipitation( i, j )
-             ENDIF
-
-!
 !--          Sink or source of scalar concentration due to canopy elements
              IF ( plant_canopy )  CALL plant_canopy_model( i, j, 5 )
@@ -788,6 +767,5 @@
 !--          If required, calculate prognostic equations for rain water content 
 !--          and rain drop concentration
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.              &
-                  precipitation )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 !
 !--             Calculate prognostic equation for rain water content
@@ -807,5 +785,4 @@
                 CALL diffusion_s( i, j, qr, qrsws, qrswst, wall_qrflux )
 
-                CALL user_actions( i, j, 'qr-tendency' )
 !
 !--             Prognostic equation for rain water content
@@ -848,5 +825,4 @@
                 CALL diffusion_s( i, j, nr, nrsws, nrswst, wall_nrflux )
 
-                CALL user_actions( i, j, 'nr-tendency' )
 !
 !--             Prognostic equation for rain drop concentration
@@ -971,6 +947,6 @@
 
 !
-!-- If required, calculate cloud microphysical impacts (two-moment scheme)
-    IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                       &
+!-- If required, calculate cloud microphysical impacts
+    IF ( cloud_physics  .AND.  .NOT. microphysics_sat_adjust  .AND.            &
          ( intermediate_timestep_count == 1  .OR.                              &
            call_microphysics_at_all_substeps )                                 &
@@ -1254,10 +1230,4 @@
 
 !
-!--    If required compute impact of latent heat due to precipitation
-       IF ( cloud_physics  .AND.  icloud_scheme == 1  .AND.  precipitation )  THEN
-          CALL impact_of_latent_heat
-       ENDIF
-
-!
 !--    Consideration of heat sources within the plant canopy
        IF ( plant_canopy .AND. ( cthf /= 0.0_wp ) ) THEN
@@ -1459,11 +1429,4 @@
        
 !
-!--    If required compute decrease of total water content due to
-!--    precipitation
-       IF ( cloud_physics  .AND.  icloud_scheme == 1  .AND.  precipitation )  THEN
-          CALL calc_precipitation
-       ENDIF
-
-!
 !--    Sink or source of scalar concentration due to canopy elements
        IF ( plant_canopy ) CALL plant_canopy_model( 5 )
@@ -1530,5 +1493,5 @@
 !--    If required, calculate prognostic equations for rain water content 
 !--    and rain drop concentration
-       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )  THEN
+       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 
           CALL cpu_log( log_point(52), 'qr-equation', 'start' )
@@ -1565,6 +1528,4 @@
 
           CALL diffusion_s( qr, qrsws, qrswst, wall_qrflux )
-
-          CALL user_actions( 'qr-tendency' )
 
 !
@@ -1639,6 +1600,4 @@
 
           CALL diffusion_s( nr, nrsws, nrswst, wall_nrflux )
-
-          CALL user_actions( 'nr-tendency' )
 
 !
@@ -1821,5 +1780,5 @@
 !
 !-- If required, calculate cloud microphysical impacts (two-moment scheme)
-    IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                       &
+    IF ( cloud_physics  .AND.  .NOT. microphysics_sat_adjust  .AND.            &
          ( intermediate_timestep_count == 1  .OR.                              &
            call_microphysics_at_all_substeps )                                 &
@@ -2079,10 +2038,4 @@
 
 !
-!--    If required compute impact of latent heat due to precipitation
-       IF ( cloud_physics  .AND.  icloud_scheme == 1  .AND.  precipitation )  THEN
-          CALL impact_of_latent_heat
-       ENDIF
-
-!
 !--    Consideration of heat sources within the plant canopy
        IF ( plant_canopy .AND. ( cthf /= 0.0_wp ) ) THEN
@@ -2256,11 +2209,4 @@
 
 !
-!--    If required compute decrease of total water content due to
-!--    precipitation
-       IF ( cloud_physics  .AND.  icloud_scheme == 1  .AND.  precipitation )  THEN
-          CALL calc_precipitation
-       ENDIF
-
-!
 !--    Sink or source of scalar concentration due to canopy elements
        IF ( plant_canopy ) CALL plant_canopy_model( 5 )
@@ -2311,5 +2257,5 @@
 !--    If required, calculate prognostic equations for rain water content 
 !--    and rain drop concentration
-       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )  THEN
+       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
 
           CALL cpu_log( log_point(52), 'qr-equation', 'start' )
@@ -2346,6 +2292,4 @@
           CALL diffusion_s( qr, qrsws, qrswst, wall_qrflux )
 
-          CALL user_actions( 'qr-tendency' )
-
 !
 !--       Prognostic equation for rain water content
@@ -2403,6 +2347,4 @@
 
           CALL diffusion_s( nr, nrsws, nrswst, wall_nrflux )
-
-          CALL user_actions( 'nr-tendency' )
 
 !
Index: palm/trunk/SOURCE/surface_layer_fluxes.f90
===================================================================
--- palm/trunk/SOURCE/surface_layer_fluxes.f90	(revision 1821)
+++ palm/trunk/SOURCE/surface_layer_fluxes.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! icloud_scheme replaced by microphysics_*
 ! 
 ! Former revisions:
@@ -134,9 +134,9 @@
     USE control_parameters,                                                    &
         ONLY:  cloud_physics, constant_heatflux, constant_waterflux,           &
-               coupling_mode, g, humidity, ibc_e_b, ibc_pt_b, icloud_scheme,   &
+               coupling_mode, g, humidity, ibc_e_b, ibc_pt_b,                  &
                initializing_actions, kappa, intermediate_timestep_count,       &
                intermediate_timestep_count_max, large_scale_forcing, lsf_surf, &
-               message_string, most_method, neutral, passive_scalar,           &
-               precipitation, pt_surface, q_surface, run_coupled,              &
+               message_string, microphysics_seifert, most_method, neutral,     &
+               passive_scalar, pt_surface, q_surface, run_coupled,             &
                surface_pressure, simulated_time, terminate_run, zeta_max,      &
                zeta_min 
@@ -906,5 +906,5 @@
 !
 !--    If required compute qr* and nr*
-       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  precipitation )   &
+       IF ( cloud_physics  .AND.  microphysics_seifert )   &
        THEN
 
@@ -1040,6 +1040,5 @@
 !
 !--    Compute (turbulent) fluxes of rain water content and rain drop conc.
-       IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.                    &
-            precipitation )  THEN
+       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
           !$OMP PARALLEL DO
           !$acc kernels loop independent present( nrs, nrsws, qrs, qrsws, us )
Index: palm/trunk/SOURCE/swap_timelevel.f90
===================================================================
--- palm/trunk/SOURCE/swap_timelevel.f90	(revision 1821)
+++ palm/trunk/SOURCE/swap_timelevel.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-!
+! icloud_scheme replaced by microphysics_*
 !
 ! Former revisions:
@@ -97,6 +97,7 @@
 
     USE control_parameters,                                                    &
-        ONLY:  cloud_physics, constant_diffusion, humidity, icloud_scheme,     &
-               neutral, ocean, passive_scalar, precipitation, timestep_count
+        ONLY:  cloud_physics, constant_diffusion, humidity,                    &
+               microphysics_seifert, neutral, ocean, passive_scalar,           &
+               timestep_count
 
     USE indices,                                                               &
@@ -160,5 +161,5 @@
     IF ( humidity  .OR.  passive_scalar )  THEN
        q = q_p             
-       IF ( cloud_physics  .AND.  icloud_scheme == 0 )  THEN
+       IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
           qr = qr_p
           nr = nr_p
@@ -193,6 +194,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              q => q_1;    q_p => q_2
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
-                  precipitation )  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qr => qr_1;    qr_p => qr_2
                 nr => nr_1;    nr_p => nr_2
@@ -222,6 +222,5 @@
           IF ( humidity  .OR.  passive_scalar )  THEN
              q => q_2;    q_p => q_1
-             IF ( cloud_physics  .AND.  icloud_scheme == 0  .AND.  &
-                  precipitation)  THEN
+             IF ( cloud_physics  .AND.  microphysics_seifert )  THEN
                 qr => qr_2;    qr_p => qr_1
                 nr => nr_2;    nr_p => nr_1
Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1821)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-!
+! icloud_scheme replaced by microphysics_*
 !
 ! Former revisions:
@@ -213,9 +213,10 @@
                dt_dopr_listing, dt_dosp, dt_dots, dt_dvrp, dt_run_control,     &
                end_time, first_call_lpm, galilei_transformation, humidity,     &
-               icloud_scheme, intermediate_timestep_count,                     &
+               intermediate_timestep_count,                                    &
                intermediate_timestep_count_max, large_scale_forcing,           &
-               loop_optimization, lsf_surf, lsf_vert, masks, mid, nest_domain, &
+               loop_optimization, lsf_surf, lsf_vert, masks,                   &
+               microphysics_seifert, mid, nest_domain,                         &
                neutral, nr_timesteps_this_run, nudging,                        &
-               ocean, on_device, passive_scalar, precipitation,                &
+               ocean, on_device, passive_scalar,                               &
                prho_reference, pt_reference, pt_slope_offset, random_heatflux, &
                run_coupled, simulated_time, simulated_time_chr,                &
@@ -486,5 +487,5 @@
                 IF (humidity  .OR.  passive_scalar)  THEN
                    CALL exchange_horiz( q_p, nbgp )
-                   IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                   IF ( cloud_physics .AND. microphysics_seifert )  THEN
                       CALL exchange_horiz( qr_p, nbgp )
                       CALL exchange_horiz( nr_p, nbgp )
@@ -553,5 +554,5 @@
                 IF (humidity  .OR.  passive_scalar)  THEN
                    CALL exchange_horiz( q_p, nbgp )
-                   IF ( cloud_physics .AND. icloud_scheme == 0 )  THEN
+                   IF ( cloud_physics .AND. microphysics_seifert )  THEN
                       CALL exchange_horiz( qr_p, nbgp )
                       CALL exchange_horiz( nr_p, nbgp )
@@ -642,6 +643,5 @@
              IF (humidity  .OR.  passive_scalar)  THEN
                 CALL exchange_horiz( q_p, nbgp )
-                IF ( cloud_physics .AND. icloud_scheme == 0  .AND.  &
-                     precipitation )  THEN
+                IF ( cloud_physics .AND. microphysics_seifert )  THEN
                    CALL exchange_horiz( qr_p, nbgp )
                    CALL exchange_horiz( nr_p, nbgp )
Index: palm/trunk/SOURCE/user_actions.f90
===================================================================
--- palm/trunk/SOURCE/user_actions.f90	(revision 1821)
+++ palm/trunk/SOURCE/user_actions.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! qr/nr-tendency removed.
 ! 
 ! Former revisions:
@@ -161,10 +161,4 @@
 
 
-          CASE ( 'qr-tendency' )
-
-
-          CASE ( 'nr-tendency' )
-
-
           CASE DEFAULT
              message_string = 'unknown location "' // location // '"'
@@ -225,10 +219,4 @@
 
 
-          CASE ( 'qr-tendency' )
-
-
-          CASE ( 'nr-tendency' )
-
-
           CASE ( 'before_timestep', 'after_integration', 'after_timestep' )
              message_string = 'location "' // location // '" is not ' // &
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 1821)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 1822)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! icloud_scheme replaced by microphysics_*
 ! 
 ! Former revisions:
@@ -102,5 +102,5 @@
     USE control_parameters,                                                    &
         ONLY:  iran, humidity, passive_scalar, cloud_physics, cloud_droplets,  &
-               icloud_scheme, precipitation, ocean, topography
+               microphysics_seifert, ocean, topography
                 
     USE indices,                                                               &
@@ -240,10 +240,10 @@
              WRITE ( 14 )  'ql_av               ';  WRITE ( 14 )  ql_av
           ENDIF
-          IF ( icloud_scheme == 0  .AND.  .NOT. cloud_droplets )  THEN
+          IF ( .NOT. cloud_droplets )  THEN
              WRITE ( 14 )  'qc                  ';  WRITE ( 14 )  qc
              IF ( ALLOCATED( qc_av ) )  THEN
                 WRITE ( 14 )  'qc_av               ';  WRITE ( 14 )  qc_av
              ENDIF
-             IF ( precipitation )  THEN
+             IF ( microphysics_seifert )  THEN
                 WRITE ( 14 )  'nr                  ';  WRITE ( 14 )  nr
                 IF ( ALLOCATED( nr_av ) )  THEN
